package trz.gaia;

import trz.gaia.*;
import java.util.*;

/**
Implementa la parte relativa alla gestione degli ascoltatori e al nome<br>
L' unico ascoltatore implementato parzialmente e' il RouteListener che deve essere
trattato in modo particolare a seocnda di come si decide di gestire la spedizione dei 
pacchetti.
*/


//### sistemare meglio le exception

public abstract class AbstractCellula implements Cellula {

	String nome = null;
	
	/**
	Setta il nome di questa cellula
	*/
	public void setNome(String nome) {
		this.nome = nome;
	}

	/**
	recupera il nome
	*/
	public String getNome() {
		return nome;
	}
	
	//GESTIONE ASCOLTATORI
	protected Vector cellulaListener = new Vector();
	protected Vector pcktListener = new Vector();
	protected Vector routeListener = new Vector();
	
	public void addCellulaChangedListener(CellulaChangedListener listener) {
		cellulaListener.add(listener);
	}
	public void removeCellulaChangedListener(CellulaChangedListener listener) {
		cellulaListener.remove(listener);
	}
	protected void notifyCellulaChangedListener(CellulaChangedEvent e) {
		//###differenziare 	questo metodo in base ai metodi dell' interfaccia listener
		for (int i = 0; i < cellulaListener.size(); i++)
			((CellulaChangedListener)cellulaListener.elementAt(i)).cellulaChanged(e);
	}
	
	public void addPacketListener(PacketListener listener) {
		pcktListener.add(listener);
	}
	public void removePacketListener(PacketListener listener) {
		pcktListener.remove(listener);
	}
	protected void notifyPacketListener(PacketEvent e) {
		//###differenziare 	questo metodo in base ai metodi dell' interfaccia listener
		for (int i = 0; i < pcktListener.size(); i++)
			((PacketListener)pcktListener.elementAt(i)).packetSent(e);
	}

	/**
	la cellula non genera RouteEvent: ogni ascoltatore viene "riagganciato" sui 
	singoli pacchetti spediti
	*/
	public void addRouteListener(RouteListener listener) {
		routeListener.add(listener);
	}
	public void removeRouteListener(RouteListener listener) {
		routeListener.remove(listener);
	}
	protected abstract void notifyRouteListener(RouteEvent e);
} 
