package trz.gaia;

/**
Interfaccia base per tutte le cellule.
*/


//### decidere meglio se/come gestire le exception

public interface Cellula {

	/**
	Ritorna le connessioni aperte da questa cellula
	*/
	//passare ad array !
	public java.util.Vector getConnessioni();
	
	/**
	Setta il nome di questa cellula
	*/
	public void setNome(String nome);

	/**
	recupera il nome
	*/
	public String getNome();

	/**
	ritorna un valore descrittivo dello stato (non e' direttamente legato al numero di con aperte)
	*/
	public int getStato();
	
	/**
	TEMP TEMP TEMP
	*/
	public int accetta(Connessione con);
	
	/**
	Il metodo che viene chiamato ad ogni tick
	*/
	public void esegui();

	/**
	Apre una connessione con la cellula passata
	*/
	public void apriConnessione(String nomeCellulaTo);
	
	/**
	Chiude la connessione con la cellula passata
	*/
	public void chiudiConnessione(String nomeCellulaTo);

	/**
	Esce da gaia senza chiudere le connessioni
	*/
	public void crash();
	
	/**
	Inizia il giro per entrare in gaia 
	*/
	public void entra();
	
	/**
	Esce "gentilmente" da gaia
	*/
	public void esci();

	/**
	Spedisce il packet al destinatario
	*/
	public void sendPacket(Packet pckt);

	
	//GESTIONE ASCOLTATORI
	
	public void addCellulaChangedListener(CellulaChangedListener listener);
	public void removeCellulaChangedListener(CellulaChangedListener listener);

	public void addPacketListener(PacketListener listener);
	public void removePacketListener(PacketListener listener);

	//la cellula non genera RouteEvent: ogni ascoltatore viene "riagganciato" sui 
	//singoli pacchetti spediti
	public void addRouteListener(RouteListener listener);
	public void removeRouteListener(RouteListener listener);
	
} 
