package trz.gaia.rna;

import trz.gaia.*;
import java.util.*;

/**
Classe di test
*/


//### sistemare meglio le exception

public class CellulaTest extends AbstractCellula {

	Connessione con = null;
	
	/**
	Apre una con con la cellula specificata
	*/
	public CellulaTest(String nome, String nomeTo) {
		setNome(nome);
		con = LinkLayer.getInstance().getConnessione(this, nomeTo);
	}

	/**
	Gestisce l' apertura di una nuova connessione. Ritorna un numero >= 0 se ok,
	minore altrimenti.
	*/
	public int accetta(String nomeCellula) {
	}

	/**
	Il metodo che viene chiamato ad ogni tick
	*/
	public void esegui() {
	
		//controllo se ci sono msg sul link layer (svuoto tutta la coda)
		LinkPacket lpckt = null;
		while ((lpckt = fetchPacket()) != null) {
			switch(lpckt.getTipo()) {
				case LinkPacket.SYN: //ACKko tutto
					LinkPacket newLpackt = new LinkPacket();
					newLpackt.setTipo(LinkPacket.ACK);
					LinkLayer.getInstance().put(newLpackt, lpckt.getFrom());
					break;
				default :   //differenziare in base al motivo del rifiuto
					LinkPacket newLpackt = new LinkPacket();
					newLpackt.setTipo(LinkPacket.RST);
					LinkLayer.getInstance().put(newLpackt, lpckt.getFrom());
			}
		}//fine loop link layer
	
		//controllo se ci sono msg (uno per volta)
		Packet pckt = con.read();
		if (pckt != null) {
			String dati = pckt.getDati();
			if (dati.equals("PING"))
				con.send("PONG");
			else if (dati.equals("PONG"))
				System.out.println(getNome() + ": PONG da " + pckt.getNomeFrom() + " :)");
			//else bho
		}
		
		//spedisco i miei
		Random r = new Random();
		if (r.nextInt(100) < 2) {
			//System.out.println("mando ping");
			con.send("PING");
		}
		if (r.nextInt(100) < 3)
			con.send("ALTRO");
	}

	/**
	Manda un LinkPacket alla cellula
	*/
	public void putPacket(LinkPacket lpckt) {
		linkCoda.add(lpckt);
	}

	/**
	Recupera i LinkPacket della cellula
	*/
	public LinkPacket fetchPacket() {
		if (linkCoda.size() >  0)
			return (LinkPacket)linkCoda.remove(0);
		return null;
	}
	
	/**
	Apre una connessione con la cellula passata
	*/
	public void apriConnessione(String nomeTo) {
		notifyCellulaChangedListener(null);
	}
	
	/**
	Chiude la connessione con la cellula passata
	*/
	public void chiudiConnessione(String nomeTo) {
		notifyCellulaChangedListener(null);
	}

	/**
	Esce da gaia senza chiudere le connessioni
	*/
	public void crash() {}
	
	/**
	Entra in gaia (tenta di aprire le connessioni, ecc.).
	*/
	public void entra() {}
	
	/**
	Esce "gentilmente" da gaia
	*/
	public void esci() {}

	/**
	Spedisce il packet al destinatario
	*/
	public void sendPacket(Packet pckt) {}

	//GESTIONE ASCOLTATORI
	protected void notifyRouteListener(RouteEvent e) {
		//###differenziare 	questo metodo in base ai metodi dell' interfaccia listener
		for (int i = 0; i < routeListener.size(); i++)
			((RouteListener)routeListener.elementAt(i)).cellulaReached(e);
	}
} 
