package trz.gaia.util;

/*
Semaforo e' tutto final, per cui non posso estenderlo.
*/

public class TimeOutSemaforo {

	private static final long WAIT = 5;
	private static final long NUM_RETRY = 12;
	private static final long TIMEOUT = WAIT * NUM_RETRY;

	private boolean occupato = false;
	
	public TimeOutSemaforo() {
		//this("");
	}
	
	/*public TimeOutSemaforo(String nome) {
		super(nome);
	}*/
	
	public final synchronized void get() {
		try {
			while (occupato)
				wait();
		}catch(InterruptedException e){/*non faccio nulla*/}
		occupato = true;
	}

	public final synchronized void free() {

		occupato = false;
		notifyAll();	//basta un notify ?
	}

	public final synchronized void timeGet() {
		
		//mettere il semaforo
		long fine = System.currentTimeMillis() + TIMEOUT;
		boolean preso = false;
		//mi aspetto che nella maggior parte dei casi il lock venga preso al primo tentativo,
		//(o al secondo) quindi lascio dentro il try (verificare se/quando questo e' vero) 
		//int i = 0;
		//System.out.println("PROVO " + i++);
		do {
			
			preso = tryGet();	//duplicare il codice della tryGet per guadagnare qualcosa ?
			if(preso)
				break;
			//System.out.println("###########RIPROVO " + i++);
			try {
				wait(WAIT);
			}catch(InterruptedException ie){/*Non faccio nulla*/}
		}while (System.currentTimeMillis() < fine);
		if (!preso)
			throw new TimeOutException();	//uso un exception perche' tutte le altre classid ella catena
											//(linklayer, ecc.) non sono strutturate in modo da avere un valore
											//di ritorno particolare da usare in questo caso.
	}
	
	//metterla private per risparmiarsi un lock ?
	public synchronized boolean tryGet() {
		if (occupato)
			return false;
		occupato = true;
		return true;
	}	
}
