/*
 */
package trz.gaia.view; 

import trz.gaia.*;
 
import java.util.*;
import java.awt.*;
import java.awt.event.*;


public class GraphPanel extends Panel implements MouseListener, MouseMotionListener {
	
   int nnodes;
   CellulaView nodes[] = new CellulaView[100];

	GraphPanel() {
		addMouseListener(this);
	}

	int findNode(String lbl) {
		for (int i = 0 ; i < nnodes ; i++) {
			if (nodes[i].lbl.equals(lbl)) {
				return i;
			}
		}
		//return addNode(lbl);
		return -1;
   }
	
	//int addNode(String lbl) {
	int addNode(CellulaView n) {
	
		//System.out.println("aggiunto nodo");
		//CellulaView n = new CellulaView(lbl);
		n.x = 10 + (int)(380*Math.random());
		n.y = 10 + (int)(380*Math.random());
		//n.lbl = lbl;
		nodes[nnodes] = n;
		return nnodes++;
	}

    CellulaView pick;
    //boolean pickfixed;
    Image offscreen;
    Dimension offscreensize;
    Graphics offgraphics;

    //final Color fixedColor = Color.red;
    //final Color selectColor = Color.pink;
    //final Color edgeColor = Color.black;
    //final Color stressColor = Color.darkGray;
    //final Color arcColor1 = Color.black;
    //final Color arcColor2 = Color.pink;
    //final Color arcColor3 = Color.red;
	 	
	//null se non la trovo
	private CellulaView trovaCellula(String nome) {
		
		for (int i = 0 ; i < nnodes ; i++)
			if (nodes[i].lbl.equals(nome))
				return nodes[i];
		return null;
	}
		
	private void disegnaConnessioni(Graphics g, CellulaView cellula) {

	  	Cellula model = cellula.getModel();
      Vector listaCon = model.getConnessioni();

      //Graphics g = main.getGraphics();
      //g.setColor(Color.white);
      //g.clearRect(0, 0, main.getSize().width, main.getSize().height);

      g.setColor(Color.black);

      Connessione con = null;
		for (int i = 0; i < listaCon.size(); i++) {
			
			//###ridisegno due volte le stesse: pace
			con = (Connessione)listaCon.elementAt(i);
			CellulaView from = trovaCellula(con.getNomeFrom());
			CellulaView to = trovaCellula(con.getNomeTo());

			//tmp.view.font = new Font("Arial", Font.BOLD, 14);
			/*
			g.drawLine( from.view.getLocation().x + from.view.getSize().width/2, 
                    from.view.getLocation().y + from.view.getSize().height/2, 
                    to.view.getLocation().x + to.view.getSize().width/2, 
                    to.view.getLocation().y + to.view.getSize().height/2);*/
			//ogni cellula nextElement disegna meta'
			int xFrom = from.x;
			int yFrom = from.y;
			int xTo;
			if (to.x > from.x)
		  		xTo = from.x + (to.x - from.x)/2;
			else
		  		xTo = from.x - (from.x - to.x)/2;
			int yTo;
			if (to.y > from.y)
		  		yTo = from.y + (to.y - from.y)/2;
			else
		  		yTo = from.y - (from.y - to.y)/2;
				  
		  g.drawLine( xFrom, yFrom,
                    xTo, yTo);
		  //g.setColor(Color.yellow);
		  //g.drawLine( xTo, yTo,
        //            to.x, to.y);
		  //tmp.view.update();
      }
  }
	 
    public synchronized void update(Graphics g) {
	Dimension d = getSize();
	if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
	    offscreen = createImage(d.width, d.height);
	    offscreensize = d;
	    offgraphics = offscreen.getGraphics();
	    offgraphics.setFont(getFont());
	}
	
	offgraphics.setColor(getBackground());
	offgraphics.fillRect(0, 0, d.width, d.height);
	/*for (int i = 0 ; i < nedges ; i++) {
	    Edge e = edges[i];
	    int x1 = (int)nodes[e.from].x;
	    int y1 = (int)nodes[e.from].y;
	    int x2 = (int)nodes[e.to].x;
	    int y2 = (int)nodes[e.to].y;
	    int len = (int)Math.abs(Math.sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)) - e.len);
	    offgraphics.setColor((len < 10) ? arcColor1 : (len < 20 ? arcColor2 : arcColor3)) ;
	    offgraphics.drawLine(x1, y1, x2, y2);
	    if (stress) {
		String lbl = String.valueOf(len);
		offgraphics.setColor(stressColor);
		offgraphics.drawString(lbl, x1 + (x2-x1)/2, y1 + (y2-y1)/2);
		offgraphics.setColor(edgeColor);
	    }
	}
		 */

	FontMetrics fm = offgraphics.getFontMetrics();
	for (int i = 0 ; i < nnodes ; i++)
		 disegnaConnessioni(offgraphics, nodes[i]);
	for (int i = 0 ; i < nnodes ; i++) {
	    nodes[i].paintNode(offgraphics, fm);
	}
	
	g.drawImage(offscreen, 0, 0, null);
    }

    //1.1 event handling
    public void mouseClicked(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
        addMouseMotionListener(this);
	double bestdist = Double.MAX_VALUE;
	int x = e.getX();
	int y = e.getY();
	for (int i = 0 ; i < nnodes ; i++) {
	    CellulaView n = nodes[i];
	    double dist = (n.x - x) * (n.x - x) + (n.y - y) * (n.y - y);
	    if (dist < bestdist) {
		pick = n;
		bestdist = dist;
	    }
	}
	//pickfixed = pick.fixed;
	//pick.fixed = true;
	pick.x = x;
	pick.y = y;
	repaint();
	e.consume();
    }

    public void mouseReleased(MouseEvent e) {
		 
		 //System.out.println("rilascio il mouse");
        removeMouseMotionListener(this);
        if (pick != null) {
            pick.x = e.getX();
            pick.y = e.getY();
            //pick.fixed = pickfixed;
            pick = null;
        }
	repaint();
	e.consume();
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseDragged(MouseEvent e) {
	pick.x = e.getX();
	pick.y = e.getY();
	repaint();
	e.consume();
    }

    public void mouseMoved(MouseEvent e) {
    }

}


