package trz.gaia.view;

import java.awt.*;
import java.awt.event.*;

import trz.gaia.*;
import trz.gaia.rna.*;
import trz.gaia.util.*;

public class TestView extends Frame implements TickListener, PacketListener, CellulaChangedListener {

	SingleThreadGaia gaia = new SingleThreadGaia();
	//GaiaView view = new GaiaView(gaia);
	
	public static void main(String[] args) throws Exception {
	
		TestView t = new TestView();
		t.esegui();
	}

	GraphPanel panel = new GraphPanel();
	
	public void esegui() throws Exception {
	
		setLayout(new BorderLayout());
		add("Center", panel);
		
		setSize(500, 500);
		show();
		panel.repaint();
		
		addWindowListener(
			new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			}
		);
		
		gaia.addTickListener(this);

		addCellule(10);
		
		gaia.avvia();
	}
	
	public void addCellule(int numero) {
		
		for (int i = 0; i < numero; i++) {
		
			CellulaTest c = new CellulaTest("Nodo" + i);
			gaia.addCellula(c);
			
			//view.addCellula(new CellulaView(c));
			panel.addNode(new CellulaView(c));
			
			ListaCellule.put(c);
			c.addCellulaChangedListener(this);
			c.addPacketListener(this);
		}
	}
	
	public void packetSent(PacketEvent e){
		//System.out.println("packet sent " + e + " - " + e.getPacket().getDati());
	}
	public void packetReceived(PacketEvent e){
		//System.out.println("packet received " + e + " - " + e.getPacket().getDati());
	}
	public void packetDiscarded(PacketEvent e){}

	public void cellulaChanged(CellulaChangedEvent e){
		panel.repaint();
		System.out.println("cellula changed " + e + " - " 
							+ (e.getTipo() == CellulaChangedEvent.APERTA_CON ? "aperta":"chiusa"));
		System.out.println((char)7);
	}
	public void cellulaEntered(CellulaChangedEvent e){}
	public void cellulaExited(CellulaChangedEvent e){}
	public void cellulaCrashed(CellulaChangedEvent e){}

	public void tickEvent(TickEvent e){
		
		int tc = e.getTickCount();
		if (tc % 1000 == 0)
			System.out.println(tc);
		//panel.repaint();
	}

}
