package trz.gaia.rna;

import trz.gaia.*;
import trz.gaia.util.*;
import java.util.*;
import java.io.*;

/**
Classe di test
*/


//### sistemare meglio le exception

public class CellulaTest extends CellulaBase {

	/**
	Apre una con con la cellula specificata
	*/
	public CellulaTest(String nome) {
		super(nome);
	}
		
	/**
	Il metodo che viene chiamato ad ogni tick
	*/
	public void esegui() {

		controllaConnessioni();
		controllaAggregazione();
		chiudiRandom();
		try {
			gestisciMsg();
		}catch(IOException e) {
			System.out.println(getNome() + ": Errore durante la gestione dei msg: " + e);
		}
	}
	
	Random rndPing = new Random(); //generatore per decidere se pingare una con
	protected void controllaConnessioni() {
	
		if (rndPing.nextInt(1000) > 50)
			return;
		
		//controllo se qualche con e' chiusa pingando (nextElement chiudo una ad ogni giro)
		synchronized(mutexListaCon) {
			int idx = -1;
			try {
				for (int i = 0 ; i < listaCon.size(); i++){
				
					idx = i;
					Connessione con = (Connessione)listaCon.elementAt(i);
					//System.out.println(getNome() + ": scrivo ping");
					con.write("PING");
					//System.out.println(getNome() + ": scritto ping");
				}
			}
			catch(IOException e) {
				//System.out.println(getNome() + ": connessione trovata chiusa " + e);
				//System.out.println(getNome() + ": " + listaCon);
				chiudiConnessione(idx);
				//System.out.println(getNome() + ": " + listaCon);
			}
		}//fine lock
	}

	protected void controllaAggregazione() {
	
		//qui dovrei controllare a che livello sono (embirone, instabile, ecc.) e
		//decidere se devo aprire altre con.

		boolean exit = false;
		while(!exit) {
			//System.out.println("altro giro");
			semaforoCon.get();
			synchronized(mutexListaCon) {

				if (listaCon.size() < N) {
			
					Cellula cellula = trz.gaia.util.ListaCellule.get();	//una cellula a caso
					//System.out.println("provo " + cellula);
					boolean ok = true;
					ok &= (this != cellula);
					for (int i = 0 ; i < listaCon.size(); i++)
						ok &= !((Connessione)listaCon.elementAt(i)).getNomeTo().equals(cellula.getNome());
			
					if (ok) {
						try {
							apriConnessione(cellula.getNome());
						}catch(TimeOutException e) {
							semaforoCon.free();
							//System.out.println("time out altrui: rilascio");
							try{Thread.sleep(75);}catch(InterruptedException ie){}
							continue;
						}
						//else
							//System.out.println(getNome() + ": non va bene " + cellula.getNome() + " (" + listaCon);
					}
					//else
						//System.out.println(getNome() + ": non va bene " + cellula.getNome() + " (" + listaCon);
				}//fine if (listaCon)
				//else
					//System.out.println(getNome() + ": ok " + listaCon);
				//se ho gia' tutte le con o se la cellula con cui ho provato non va bene esco
				exit = true;
			}//fine lock
			semaforoCon.free();
		}//fine while
	}

	Random rndChiudi = new Random(); //generatore per decidere se chiudere le con
	
	protected void chiudiRandom() {
		//ogni tanto chiudo una con
		int ran = rndChiudi.nextInt(10000);
		synchronized(mutexListaCon) {
			if (ran < 50 && listaCon.size() > 0) {
				//System.out.println(getNome() + ": chiudo con " + listaCon.elementAt(0));
				//System.out.println(getNome() + ": " + listaCon);
				chiudiConnessione(0);
				//System.out.println(getNome() + ": " + listaCon);
			}
		}//fine lock
	}
	
	protected void gestisciMsg() throws IOException {
		leggiMsg();
		inviaMsg();
	}	

	protected void leggiMsg() throws IOException {
		
		//controllo se ci sono msg (uno per volta)
		//questo for sarebbe da lockkare
		for (int i = 0; i < listaCon.size(); i++) {
			
			Connessione con = (Connessione)listaCon.elementAt(i);
			//System.out.println(getNome() + ": leggo");
			Packet pckt = con.read();
			//System.out.println(getNome() + ": letto");
			if (pckt != null) {
				//TEMP: spostare nella con
				
				String dati = pckt.getDati();
				if (dati.equals("PING"))
					con.write("PONG");
				//else if (dati.equals("PONG"))
				//	System.out.println(getNome() + ": PONG da " + pckt.getNomeFrom() + " :)");
				//else
				//	System.out.println(getNome() + ": leggo " + dati + " da " + pckt.getNomeFrom());
			}
		}
	}

	Random rndMsg = new Random();	//per decidere se e cosa spedire
	int numMsg = 0;
	
	protected void inviaMsg() throws IOException {
		
		//questo for sarebbe da lockkare
		for (int i = 0; i < listaCon.size(); i++) {
			
			Connessione con = (Connessione)listaCon.elementAt(i);
			//spedisco i miei
			//TEMP TEMP aumento la velocita' di spedizione per il test con due cellule
			if (rndMsg.nextInt(1000) < 50) {
				//System.out.println("mando ping");
				con.write(getNome() + ": CIAO_" + numMsg++);
			}
			//if (rndMsg.nextInt(100) < 3)
			//	con.write("ALTRO");
		}//fine for
	}	
} 
